%%%%% ps3_question1: inflation dynamics under optimal monetary policy

clearvars
close all

beta    = 0.95;
phi     = 0.8;
kappa   = 0.15;
lambda  = 1;
sigmau  = 0.015;

%%%%% algebra gives the following coefficients

psi_piu = 1/((1-phi*beta)+(kappa^2)*lambda);
psi_xu  = -kappa*lambda*psi_piu;

%%%%% simulated cost push shocks

T = 250;          %% calculate for T periods after shock

time   = (1:1:T)';

shock  = randn(size(time))*sigmau;

ut     = zeros(size(time));

ut(1)  = phi*0 + shock(1);

for t=2:length(time)
     
ut(t)  = phi*ut(t-1) + shock(t);   %% unemployment rate
    
end    

pit    = psi_piu*ut;
xt     = psi_xu*ut;

figure(1)
set(gcf,'DefaultLineLineWidth', 2);
scatter(xt,pit)
set(get(gcf,'CurrentAxes'),'FontSize',16,'LineWidth', 1.5)
ylabel('inflation, $\hat{\pi}_t$','Interpreter','latex')
xlabel('output gap, $\hat{x}_t$','Interpreter','latex')
set(gca,'DefaultTextInterpreter', 'latex','TickLabelInterpreter','latex')
box on







