%%%%% ps3_question2: discretionary monetary policy in a liquidity trap

clearvars
close all

rho     = 0.05;
sigma   = 0.5;
kappa   = 0.5;

T       = 2;
rhi     = rho;
rlo     = -rho;

pibar   = -rlo;
xbar    = (rho/kappa)*pibar;

%%%%% solve for roots of characteristic polynomial

rr      = roots([1,-rho,-kappa/sigma]);

r1      = rr(1);
r2      = rr(2);

%%%%% solve for loadings c1,c2 using boundary conditions

a11     = exp(r1*T); a12 = exp(r2*T);
a21     = r1*a11   ; a22 = r2*a12; 

A       = [a11,a12;a21,a22];

b1      = -pibar;
b2      = 0; 

b       = [b1;b2];

c       = A\b;

c1      = c(1); c2 = c(2);

check1  =  (r2/(r1-r2))*exp(-r1*T)*pibar; %% should = c1
check2  = -(r1/(r1-r2))*exp(-r2*T)*pibar; %% should = c2;

t       = linspace(0,T,200);

%%%%% general solution for inflation

pit = c1*exp(r1*t) + c2*exp(r2*t) + pibar;

%%%% implied change in inflation

Dpit = r1*c1*exp(r1*t) + r2*c2*exp(r2*t);

%%%%% implied output gap
xt   = (rho*pit - Dpit)/kappa;


figure(1)
set(gcf,'DefaultLineLineWidth', 2);
subplot(1,2,1)
plot(pit,xt,'LineWidth',2)
set(get(gcf,'CurrentAxes'),'FontSize',16,'LineWidth', 1.5)
xlabel('inflation, $\pi(t)$','Interpreter','latex')
ylabel('output gap, $x(t)$','Interpreter','latex')
set(gca,'DefaultTextInterpreter', 'latex','TickLabelInterpreter','latex')
box on

subplot(1,2,2)
plot(t,pit,'r-',t,xt,'g-','LineWidth',2)
set(get(gcf,'CurrentAxes'),'FontSize',16,'LineWidth', 1.5)
xlabel('time, $t$','Interpreter','latex')
ylabel('log deviation from steady state','Interpreter','latex')
set(gca,'DefaultTextInterpreter', 'latex','TickLabelInterpreter','latex')
l = legend('inflation $\pi(t)$','output gap $x(t)$','Location','Best');
set(l,'Interpreter','latex');
box on






